//+------------------------------------------------------------------+
//|                                                   XP_Trader.mq4  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "None"
#property link      "None"

extern double Lots=0.1;
extern int Slippage=3;
extern bool UseDST=false;

extern string EAName = "XP_Trader";
extern int MagicNumber = 65142;
extern int MaxTrades = 1;

extern int StretchPips = 5;
extern double ProfitPips = 40;
extern double StopPips = 30;
extern double TrailStartPips=30;
extern double TrailStopPips=30;
extern double BreakEvenStopPips=30;



extern bool MM = false; //Use Money Management or not
extern int RiskPercent = 1; //% of margin available per trade

datetime timeprev=0;

double price, prcopp;
datetime expiration;
int ChartPeriod, LookBack, AdjustedEntryHourA;
double Op, Hi, Lo, Cl, Range, Stop, Profit, Spread, MinDist;
double LongEntry, ShortEntry, Stretch; 
double iLots;
bool Buy=false, Sell=false, NewBuy=false, NewSell=false;
 
int init()
{
 return(0);
}

int deinit()
{
 return(0);
}

int start()
{
  
 TrailingAlls(TrailStartPips,TrailStopPips);
 BreakEvenStop(BreakEvenStopPips);
  
 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];

// if(CountTrades()<MaxTrades)
 {
  expiration = 0; 
  Spread = MarketInfo(Symbol(), MODE_SPREAD)*Point;
  MinDist = MarketInfo(Symbol(), MODE_STOPLEVEL);
  Stretch = NormalizeDouble(StretchPips*Point, Digits);
  Stop = StopPips;
  Profit = ProfitPips;
  
  double Var1 = iCustom(NULL,0,"xpMA_v4", 5, 2, 1);
  double Var2 = iCustom(NULL,0,"xpMA_v4", 5, 1, 1);
  
  
  
  if(Var1 > 1)
  {
   ClosePendingLong();
  }
    
  if(Var1 > 1)
  {
   Buy = true;
   Sell = false;
   ClosePendingShort();
   CloseShort();
  }   

  if(Var2 > 1)
  {
   ClosePendingShort();
  }

  if(Var2 > 1)
  {
   Sell = true;
   Buy = false;
   ClosePendingLong();
   CloseLong();
  }   
  

  if(MM==true) 
   iLots = LotSize(StopPips);
  else
   iLots = Lots;
    

  if (Buy && CountTrades()<MaxTrades)
  {
   RefreshRates();  
   LongEntry = Ask + Stretch; 
   price=LongEntry;
   prcopp=LongEntry-Spread;
   OpenPendingOrder(OP_BUYSTOP,iLots,price,Slippage,prcopp,Stop,Profit,EAName+" 1st",MagicNumber,expiration,Green);
   OpenPendingOrder(OP_BUYSTOP,iLots,price,Slippage,prcopp,Stop,0,EAName+" 2nd",MagicNumber,expiration,Green);
  }
  
  if (Sell && CountTrades()<MaxTrades)
  {
   RefreshRates();  
   ShortEntry = Bid - Stretch;
   price=ShortEntry;
   prcopp=ShortEntry+Spread;
   OpenPendingOrder(OP_SELLSTOP,iLots,price,Slippage,prcopp,Stop,Profit,EAName+" 1st",MagicNumber,expiration,Red);
   OpenPendingOrder(OP_SELLSTOP,iLots,price,Slippage,prcopp,Stop,Profit,EAName+" 2nd",MagicNumber,expiration,Red);
  } 
 }//Open Pending

 
 return(0);
}

double StopLong(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price-(stop*Point));
}

double StopShort(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price+(stop*Point));
}

double TakeLong(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price+(take*Point));
}

double TakeShort(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price-(take*Point));
}


void TrailingAlls(double start,double stop)
{
 int profit;
 double stoptrade;
 double stopcal;
 
 if(stop==0)
  return;
 
 int trade;
 int trades=;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderType()==OP_BUY)
  {
   profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Bid-(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
  }//Long
  
  if(OrderType()==OP_SELL)
  {
   profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Ask+(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
  }//Shrt
  
 }//for
}


void CloseLong()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
  {
   if(OrderType()==OP_BUY)
    OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);
  }
 }
}

void CloseShort()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
  {
   if(OrderType()==OP_SELL)
    OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Red);
  }
 }
}

int OpenPendingOrder(int pType,double pLots,double pLevel,int sp, double pr, int sl, int tp,string pComment,int pMagic,datetime pExpiration,color pColor)
{
  int ticket=0;
  int err=0;
  int c = 0;
  int NumberOfTries = 100;
  switch (pType)
  {
      case OP_BUYLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYLIMIT,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         }   
         break;
      case OP_BUYSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYSTOP,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLLIMIT,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLSTOP,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
  } 
  
  return(ticket);
}  

double LotSize(double StopLossInPips)
{ 
 int Leverage =  AccountLeverage(); 
 double PipValue = MarketInfo(Symbol(), MODE_TICKVALUE);
 double lotMM;

 lotMM = NormalizeDouble((AccountFreeMargin()*RiskPercent/100)/(StopLossInPips*PipValue),1);
   
   if (lotMM < 0.1) lotMM = Lots;
   if  (lotMM > 100) lotMM = 100;
   return (lotMM);
} 

int CountTrades()
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if((OrderType()==OP_SELL) || (OrderType()==OP_BUY) || 
     (OrderType()==OP_SELLSTOP) || (OrderType()==OP_BUYSTOP))
   count++;
 }//for
 return(count);
}


void ClosePendingLong()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())  continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
  {
   if(OrderType()==OP_BUYSTOP)
    OrderDelete(OrderTicket());
  }
 }
}

void ClosePendingShort()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())  continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
  {
   if(OrderType()==OP_SELLSTOP)
    OrderDelete(OrderTicket());
  }
 }
}

void BreakEvenStop(double stop)
{
 int profit;
 double stoptrade;
 double stopcal;
 double start = 1;
 
 if(stop==0)
  return;
 
 int trade;
 int trades=;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderType()==OP_BUY)
  {
   profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Bid-(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
  }//Long
  
  if(OrderType()==OP_SELL)
  {
   profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
   if(profit<start)
    continue;
   stoptrade=OrderStopLoss();
   stopcal=Ask+(stop*Point);
   if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
    OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
  }//Shrt
  
 }//for
}


